/* $Id: support_tool.h,v 1.7 2001/06/18 20:53:37 jm Exp $
 * Dynamics core support tool interface
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 1998-2000, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */
#ifndef SUPPORT_TOOL_H
#define SUPPORT_TOOL_H

struct tool_cmd_completion {
  char *cmd;
  struct tool_cmd_completion *sub;
};

/* Add a command handler */
int tool_add_command(char *cmd, /* command invocation */
		     int unique, /* unique length of invocation */
		     void (*func)(int argc, char *argv[]), /* handler function
							    */
		     char *help, /* pointer to help text (may be NULL) */
		     struct tool_cmd_completion *completions);

/* Enter monitoring mode using timout interval between monitor calls to cmd */
void tool_monitor(char *cmd, int timeout);

/* Set program's quit flag */
void tool_quit(void);

/* tool's main loop, blocks until tool terminates */
int tool_main(int argc, char *argv[]);
int parse_long_options_tools(int argc, char *argv[],
			     const char *command_name,
			     char *agent_path, int pathsize,
			     const char *package, const char *version);
#endif
